OGRE: Ogre::Volume::CSGUnarySource Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Member Functions | Static Public Attributes | List of all members
Ogre::Volume::CSGUnarySource Class Referenceabstract

Source which does a unary operation to another one. More...

`#include <OgreVolumeCSGSource.h>`

Inheritance diagram for Ogre::Volume::CSGUnarySource:
[legend]

## Public Member Functions
bool | getFirstRayIntersection (const Ray &ray, Vector3 &result, Real scale=(Real) 1.0, size_t maxIterations=5000, Real maxDistance=(Real) 10000.0) const
| Gets the first intersection of a ray with the volume. More...
virtual const Source * | getSource (void) const
| Gets the source. More...
virtual Real | getValue (const Vector3 &position) const =0
| Gets the density value at a specific position. More...
virtual Vector4 | getValueAndGradient (const Vector3 &position) const =0
| Gets the density value and gradient at a specific position. More...
Real | getVolumeSpaceToWorldSpaceFactor (void) const
| Gets a factor to come from volume coordinate to world coordinate. More...
void | serialize (const Vector3 &from, const Vector3 &to, float voxelWidth, const String &file)
| Serializes a volume source to a discrete grid file with deflated compression. More...
void | serialize (const Vector3 &from, const Vector3 &to, float voxelWidth, Real maxClampedAbsoluteDensity, const String &file)
| Same as the other serialize function but with a user definable maximum absolute density value. More...
virtual void | setSource (Source *a)
| Sets the source. More...

## Static Public Attributes
static const size_t | SERIALIZATION_CHUNK_SIZE
| The amount of items being written as one chunk during serialization. More...
static const uint32 | VOLUME_CHUNK_ID
| The id of volume files. More...
static const uint16 | VOLUME_CHUNK_VERSION
| The version of volume files. More...

## Detailed Description

Source which does a unary operation to another one.

## Member Function Documentation

## ◆ getFirstRayIntersection()

bool Ogre::Volume::Source::getFirstRayIntersection | ( | const Ray & | ray,
|  | Vector3 & | result,
|  | Real | scale = `(Real) 1.0`,
|  | size_t | maxIterations = `5000`,
|  | Real | maxDistance = `(Real) 10000.0`
| ) |  | const
| inherited

Gets the first intersection of a ray with the volume.

If you are using this together with the VolumeChunk: Beware of the possible scaling or other transformations you did on the Chunk! Do the inverse first on the ray origin. Example of a scaling with the factor 10: ray.setOrigin(ray.getOrigin() / (Real)10.0);

Parameters

  ray | The ray.
  result | Will hold the intersection point if there is an intersection.
  scale | The scaling of the volume compared to the world.
  maxIterations | The maximum amount of iterations on the ray before giving up.
  maxDistance | The maximum distance of the intersection point.

## ◆ getSource()

virtual const Source* Ogre::Volume::CSGUnarySource::getSource | ( | void |  | ) | const
| virtual

Gets the source.

Returns
  The source.

## ◆ getValue()

virtual Real Ogre::Volume::Source::getValue | ( | const Vector3 & | position | ) | const
| pure virtualinherited

Gets the density value at a specific position.

Parameters

  position | The position.

Returns
  The density.

Implemented in Ogre::Volume::GridSource, Ogre::Volume::CSGNoiseSource, Ogre::Volume::CSGScaleSource, Ogre::Volume::CSGNegateSource, Ogre::Volume::CSGDifferenceSource, Ogre::Volume::CSGUnionSource, Ogre::Volume::CSGIntersectionSource, Ogre::Volume::CSGCubeSource, Ogre::Volume::CSGPlaneSource, Ogre::Volume::CSGSphereSource, and Ogre::Volume::CacheSource.

## ◆ getValueAndGradient()

virtual Vector4 Ogre::Volume::Source::getValueAndGradient | ( | const Vector3 & | position | ) | const
| pure virtualinherited

Gets the density value and gradient at a specific position.

Parameters

  position | The position.

Returns
  A vector with x, y, z containing the gradient and w containing the density.

Implemented in Ogre::Volume::GridSource, Ogre::Volume::CSGNoiseSource, Ogre::Volume::CSGScaleSource, Ogre::Volume::CSGNegateSource, Ogre::Volume::CSGDifferenceSource, Ogre::Volume::CSGUnionSource, Ogre::Volume::CSGIntersectionSource, Ogre::Volume::CSGCubeSource, Ogre::Volume::CSGPlaneSource, Ogre::Volume::CSGSphereSource, and Ogre::Volume::CacheSource.

## ◆ getVolumeSpaceToWorldSpaceFactor()

Real Ogre::Volume::Source::getVolumeSpaceToWorldSpaceFactor | ( | void |  | ) | const
| inherited

Gets a factor to come from volume coordinate to world coordinate.

Returns
  The factor, 1.0 in the default implementation.

## ◆ serialize() [1/2]

void Ogre::Volume::Source::serialize | ( | const Vector3 & | from,
|  | const Vector3 & | to,
|  | float | voxelWidth,
|  | const String & | file
| ) |  |
| inherited

Serializes a volume source to a discrete grid file with deflated compression.

To achieve better compression, all density values are clamped within a maximum absolute value of (to - from).length() / 16.0. The values are scanned in this inner-loop-order: z, x, y. y last because there is usually the least isosurface intersection to be expected in the use case of terrain and so more often the maximum density value hit. The values are written as 16 Bit floats to save space. Note that this process is not lossless, the tradeoff is between accuracy of the source-reproduction (smaller voxelWidth) and smaller filesize (bigger voxelWidth).

Parameters

  from | The start point to scan the volume.
  to | The end point to scan the volume.
  voxelWidth | The width of a single cube in the density grid.
  file | The file to write the grid to.

## ◆ serialize() [2/2]

void Ogre::Volume::Source::serialize | ( | const Vector3 & | from,
|  | const Vector3 & | to,
|  | float | voxelWidth,
|  | Real | maxClampedAbsoluteDensity,
|  | const String & | file
| ) |  |
| inherited

Same as the other serialize function but with a user definable maximum absolute density value.

Parameters

  from | The start point to scan the volume.
  to | The end point to scan the volume.
  voxelWidth | The width of a single cube in the density grid.
  maxClampedAbsoluteDensity | The maximum absolute density value to be written into the file, influencing the compression rate.
  file | The file to write the grid to.

## ◆ setSource()

virtual void Ogre::Volume::CSGUnarySource::setSource | ( | Source * | a | ) |
| virtual

Sets the source.

Parameters

  a | The source.

## Member Data Documentation

## ◆ SERIALIZATION_CHUNK_SIZE

const size_t Ogre::Volume::Source::SERIALIZATION_CHUNK_SIZE
| staticinherited

The amount of items being written as one chunk during serialization.

## ◆ VOLUME_CHUNK_ID

const uint32 Ogre::Volume::Source::VOLUME_CHUNK_ID
| staticinherited

The id of volume files.

## ◆ VOLUME_CHUNK_VERSION

const uint16 Ogre::Volume::Source::VOLUME_CHUNK_VERSION
| staticinherited

The version of volume files.

The documentation for this class was generated from the following file:

- OgreVolumeCSGSource.h